// longer-wait.p
//
// This script is a variation on the built-in functionality of the relay module, with the following differences:
//
// * The duration that the relay stays activated, is twice the setting of the rotary switch. So, if the rotary switch is set to 3, the relay stays activated for 6 seconds.
//
// * If the rotary switch is set to 0, the relay stays activated for 1 second.

new n_wait

@signal(button) {
    if (true) {
        setrelay 1
        n_wait = rotaryswitch()
        if (n_wait == 0) {
            n_wait = 1
        }
        else {
            n_wait *= 2
        }
        sleep n_wait * 1000
        setrelay 0
    }
}


// NOTE: The lines below are required for Pawn Blocks Designer.
// If you edit or remove this comment, you will longer be able
// to edit this program with Pawn Blocks Designer.
//
//-Begin [H0738]
//- 26208	64 64	6	0
//- 17846	8 26	0	1
//- 26130	8 52	0	wait
//- 32300	8 78	1	wait	0	0
//- 22632	8 26	0	wait	1
//- 30657	8 130	1
//- 19040	8 26	0	wait	2
//- 17678	8 194	0	wait	1000
//- 17846	8 220	0	0
//-End
