// stop-on-iopin.p
//
// This script actuates the relay on a button press, and releases it when GPIO-pin 0 goes down.
//
// That is, the relay closes on a button press, and opens again when "something" pulls the first GPIO pin low. That "something" would be a sensor or stop-switch.
//
// In the "signal" event, there is a check for the state of the GPIO pin before actuating the array. The relay is not actuated if the pin is already low.

new n_state

@signal(button) {
    if (true) {
        n_state = getiopin(0)
        if (n_state != 0) {
            setrelay 1
        }
    }
}

@iopin(pin, status) {
    if (pin == 0 && status == 0) {
        setrelay 0
    }
}


// NOTE: The lines below are required for Pawn Blocks Designer.
// If you edit or remove this comment, you will longer be able
// to edit this program with Pawn Blocks Designer.
//
//-Begin [H0738]
//- 26208	48 32	2	0
//- 25922	8 26	0	state	0
//- 32300	8 52	1	state	1	0
//- 17846	8 26	0	1
//- 18359	48 177	1	0	0
//- 17846	8 26	0	0
//-End
