/* H0738 interface functions
 *
 * (c) Copyright 2023-2024, CompuPhase
 * This file is provided as is (no warranties).
 */
#pragma amxlimit  4096          /* code size (ROM) */
#pragma amxram    1024          /* total RAM for scripts (data + stack/heap) */
#pragma dynamic   128           /* stack/heap size in cells */

#pragma library   -             /* do not create a library table */
#pragma opcodeset 3             /* allow full instruction set */

native buttonserial(index)				= -1;
native random(max)                                      = -2;
native version()                                        = -3;

native settimer(milliseconds, bool: singleshot=false)   = -4;
native tickcount()                                      = -5;

native bool: transmit(const data{}, length = -1)        = -6;

native getiopin(pin)                                    = -7;
native setiopin(pin, status)                            = -8;
native setrelay(status)                                 = -9;
native rotaryswitch()                                   = -10;
native setled(status)                                   = -11;

forward @iopin(pin, status);
forward @receive(const data{}, length);
forward @signal(button);
forward @timer();

/* helper functions, used by Pawn Blocks */

stock strequal(const data1{}, const data2{}, length)
    {
    for (var i = 0; i < length && data2{i} != 0; i++)
        if (data1{i} != data2{i})
            return false
    return true
    }

