[Settings]
Label=Relay H0738
Pawn=4
Version=1
Transfer=relaytool
Properties=H0738Config

[Event]
IO-pin (change)=[io-pin]The logic level of an IO pin changed
Receive data=[receive]Data was received from the USB port
Signal (button)=[signal]A "button press" signal was receved from one of the attached buttons
Start-up=[startup]Power-up (or restart) of the device
Timer tick=[timer]A timer that "ticks" at a fixed interval

[Flow]
if=Execute the enclosed blocks only if a condition is true
else=Execute the enclosed block only if the "if" block that it is connected to, falls through
loop=Run the enclosed block mutliple times

[Action]
IO-pin (set)=[io-pin]Set a pin low or high
Relay=Toggle the relay on or off
LED=Toggle the on-board LED on or off
Sleep=Wait for a specified period
Transmit data=[transmit]Transmit data over USB

[Store]
Set variable=[set]Set a variable to a value
Random=Pick a random value between low and high limits
Increment=Increment a variable
Decrement=Decrement a variable
Multiply=Multiply a variable
Divide=Divide a variable
IO-pin (read)=[read io-pin]Get the current value of a pin, and store it in a variable
Rotary switch=[read rotary]Get the setting of the rotary switch, and store it in a variable

[Event:IO-pin (change)]
Pin number=[pin:0~1]The input pin number, either 0 or 1
Toggle=[toggle:down>0,up>1]The change in state to detect and respond to
.event=@iopin(pin, status)
.syntax=if (pin == $pin && status == $toggle) {/}

[Event:Receive data]
Data=[text]The data to receive, for this event to fire
.event=@receive(const data{}, length)
.syntax=if (strequal(data, $text, length)) {/}

[Event:Signal (button)]
Button=[button:0~4]The sequential index number of the button to respond to, or 0 for "any button"
.event=@signal(button)
.syntax=if ($button == 0 || button == $button) {/}

[Event:Start-up]
.event=@start()
.type=boot

[Event:Timer tick]
Interval=[interval:1]The tick interval in seconds or milliseconds
Unit=[!unit:seconds>1000,ms>1]The unit for the interval: seconds or milliseconds
.event=@timer()
.type=single
.config=settimer $interval * $unit, false

[Flow:if]
Variable=[!var:_>0]The variable or state to test
Condition=[!oper:is>0,is_not>1,is_below>2,is_below_or_equal>3,is_above>4,is_above_or_equal>5]The comparison operator
Value=[!value:_>0,false>1,true>2]Value or variable name

[Flow:else]

[Flow:loop]
Variable=[!var:_>0]The variable or state to test
Condition=[!oper:is>0,is_not>1,is_below>2,is_below_or_equal>3,is_above>4,is_above_or_equal>5,count_to>6]The comparison operator
Value=[!value:_>0,false>1,true>2]Value or variable name

[Action:IO-pin (set)]
Pin number=[pin:0~1]The pin number, either 0 or 1
State=[state:down>0,up>1]The level to set the pin to
.syntax=setiopin $pin, $state

[Action:LED]
State=[state:default>-1,off>0,on>1@1]The LED state; 'default' means that the LED is on while the relay is on
.syntax=setled $state

[Action:Relay]
State=[state:closed>1,open>0]The relay state to set
.syntax=setrelay $state

[Action:Sleep]
Duration=[count:_>,1]The time to wait (in seconds or milliseconds)
Unit=[!unit:seconds>1000,ms>1]The unit for the duration: seconds or milliseconds
.syntax=sleep $count * $unit

[Action:Transmit data]
Data=[text]The data to transmit
.syntax=transmit "$text"

[Store:Set variable]
Name=[!var]The variable name.
Value=[to]The value to set the variable to
.syntax=$var = $to

[Store:Increment]
Name=[!var]The variable name
Value=[by:1]The amount with which to increment the variable
Limit=[*limit:1000000000]Upper limit (don't increment beyond this value)
.syntax=[0]$var = $var + $by < $limit ? $var + $by : $limit

[Store:Decrement]
Name=[!var]The variable name
Value=[by:1]The amount with which to decrement the variable
Limit=[*limit:-1000000000]Lower limit (don't decrement to below this value)
.syntax=[0]$var = $var - $by > $limit ? $var - $by : $limit

[Store:Multiply]
Name=[!var]The variable name
Value=[by:1]The amount with which to multiply the variable
.syntax=[0]$var *= $by

[Store:Divide]
Name=[!var]The variable name
Value=[by:1]The amount with which to divide the variable
.syntax=[0]$var /= $by

[Store:Random]
Name=[!var]The variable name
Minimum=[min:_>0,1]Lowest number
Maximum=[max:_>0,10]Highest number
.syntax=[0]$var = random($max - $min + 1) + $min

[Store:IO-pin (read)]
Name=[!var]The variable name
Pin number=[pin:0~1]The pin number, either 0 or 1
.syntax=[0]$var = getiopin($pin)

[Store:Rotary switch]
Name=[!var]The variable name
.syntax=[0]$var = rotaryswitch()
